diff -ruNp linux-3.12.6/arch/x86/syscalls/syscall_64.patched.tbl linux-3.12.6-cher1/arch/x86/syscalls/syscall_64.patched.tbl
--- linux-3.12.6/arch/x86/syscalls/syscall_64.patched.tbl	1970-01-01 03:00:00.000000000 +0300
+++ linux-3.12.6-cher1/arch/x86/syscalls/syscall_64.patched.tbl	2013-12-24 13:58:59.383817161 +0400
@@ -0,0 +1,358 @@
+#
+# 64-bit system call numbers and entry vectors
+#
+# The format is:
+# <number> <abi> <name> <entry point>
+#
+# The abi is "common", "64" or "x32" for this file.
+#
++0	common	read			sys_read
++1	common	write			sys_write
+-2	common	open			sys_open
++3	common	close			sys_close
+-4	common	stat			sys_newstat
++5	common	fstat			sys_newfstat
+-6	common	lstat			sys_newlstat
+7	common	poll			sys_poll
++8	common	lseek			sys_lseek
+9	common	mmap			sys_mmap
++10	common	mprotect		sys_mprotect
+11	common	munmap			sys_munmap
+12	common	brk			sys_brk
++13	64	rt_sigaction		sys_rt_sigaction
+-14	common	rt_sigprocmask		sys_rt_sigprocmask
+15	64	rt_sigreturn		stub_rt_sigreturn
+-16	64	ioctl			sys_ioctl
+-17	common	pread64			sys_pread64
+-18	common	pwrite64		sys_pwrite64
++19	64	readv			sys_readv
++20	64	writev			sys_writev
+-21	common	access			sys_access
+-22	common	pipe			sys_pipe
++23	common	select			sys_select
++24	common	sched_yield		sys_sched_yield
++25	common	mremap			sys_mremap
+-26	common	msync			sys_msync
+-27	common	mincore			sys_mincore
+-28	common	madvise			sys_madvise
+-29	common	shmget			sys_shmget
+-30	common	shmat			sys_shmat
+-31	common	shmctl			sys_shmctl
+32	common	dup			sys_dup
+33	common	dup2			sys_dup2
++34	common	pause			sys_pause
+35	common	nanosleep		sys_nanosleep
+36	common	getitimer		sys_getitimer
+37	common	alarm			sys_alarm
+38	common	setitimer		sys_setitimer
++39	common	getpid			sys_getpid
++40	common	sendfile		sys_sendfile64
+-41	common	socket			sys_socket
+-42	common	connect			sys_connect
+-43	common	accept			sys_accept
+-44	common	sendto			sys_sendto
+-45	64	recvfrom		sys_recvfrom
+-46	64	sendmsg			sys_sendmsg
+-47	64	recvmsg			sys_recvmsg
+-48	common	shutdown		sys_shutdown
+-49	common	bind			sys_bind
+-50	common	listen			sys_listen
+-51	common	getsockname		sys_getsockname
+-52	common	getpeername		sys_getpeername
+-53	common	socketpair		sys_socketpair
+-54	64	setsockopt		sys_setsockopt
+-55	64	getsockopt		sys_getsockopt
+-56	common	clone			stub_clone
+-57	common	fork			stub_fork
+-58	common	vfork			stub_vfork
+-59	64	execve			stub_execve
+60	common	exit			sys_exit
+61	common	wait4			sys_wait4
+-62	common	kill			sys_kill
++63	common	uname			sys_newuname
+-64	common	semget			sys_semget
+-65	common	semop			sys_semop
+-66	common	semctl			sys_semctl
+-67	common	shmdt			sys_shmdt
+-68	common	msgget			sys_msgget
+-69	common	msgsnd			sys_msgsnd
+-70	common	msgrcv			sys_msgrcv
+-71	common	msgctl			sys_msgctl
+-72	common	fcntl			sys_fcntl
+-73	common	flock			sys_flock
+74	common	fsync			sys_fsync
+-75	common	fdatasync		sys_fdatasync
+-76	common	truncate		sys_truncate
+77	common	ftruncate		sys_ftruncate
++78	common	getdents		sys_getdents
+-79	common	getcwd			sys_getcwd
+-80	common	chdir			sys_chdir
+-81	common	fchdir			sys_fchdir
+-82	common	rename			sys_rename
+-83	common	mkdir			sys_mkdir
+-84	common	rmdir			sys_rmdir
+-85	common	creat			sys_creat
+-86	common	link			sys_link
+-87	common	unlink			sys_unlink
+-88	common	symlink			sys_symlink
+-89	common	readlink		sys_readlink
+-90	common	chmod			sys_chmod
+-91	common	fchmod			sys_fchmod
+-92	common	chown			sys_chown
+-93	common	fchown			sys_fchown
+-94	common	lchown			sys_lchown
+-95	common	umask			sys_umask
+-96	common	gettimeofday		sys_gettimeofday
++97	common	getrlimit		sys_getrlimit
++98	common	getrusage		sys_getrusage
+-99	common	sysinfo			sys_sysinfo
++100	common	times			sys_times
+-101	64	ptrace			sys_ptrace
++102	common	getuid			sys_getuid
+-103	common	syslog			sys_syslog
++104	common	getgid			sys_getgid
+-105	common	setuid			sys_setuid
+-106	common	setgid			sys_setgid
++107	common	geteuid			sys_geteuid
++108	common	getegid			sys_getegid
+-109	common	setpgid			sys_setpgid
++110	common	getppid			sys_getppid
++111	common	getpgrp			sys_getpgrp
+-112	common	setsid			sys_setsid
+-113	common	setreuid		sys_setreuid
+-114	common	setregid		sys_setregid
+115	common	getgroups		sys_getgroups
+-116	common	setgroups		sys_setgroups
+-117	common	setresuid		sys_setresuid
++118	common	getresuid		sys_getresuid
+-119	common	setresgid		sys_setresgid
++120	common	getresgid		sys_getresgid
++121	common	getpgid			sys_getpgid
+-122	common	setfsuid		sys_setfsuid
+-123	common	setfsgid		sys_setfsgid
++124	common	getsid			sys_getsid
++125	common	capget			sys_capget
+-126	common	capset			sys_capset
++127	64	rt_sigpending		sys_rt_sigpending
++128	64	rt_sigtimedwait		sys_rt_sigtimedwait
++129	64	rt_sigqueueinfo		sys_rt_sigqueueinfo
++130	common	rt_sigsuspend		sys_rt_sigsuspend
+-131	64	sigaltstack		sys_sigaltstack
+-132	common	utime			sys_utime
+-133	common	mknod			sys_mknod
+-134	64	uselib
+-135	common	personality		sys_personality
+-136	common	ustat			sys_ustat
+-137	common	statfs			sys_statfs
+-138	common	fstatfs			sys_fstatfs
+-139	common	sysfs			sys_sysfs
++140	common	getpriority		sys_getpriority
+-141	common	setpriority		sys_setpriority
+-142	common	sched_setparam		sys_sched_setparam
++143	common	sched_getparam		sys_sched_getparam
+-144	common	sched_setscheduler	sys_sched_setscheduler
++145	common	sched_getscheduler	sys_sched_getscheduler
++146	common	sched_get_priority_max	sys_sched_get_priority_max
++147	common	sched_get_priority_min	sys_sched_get_priority_min
++148	common	sched_rr_get_interval	+sys_sched_rr_get_interval
+-149	common	mlock			sys_mlock
+-150	common	munlock			sys_munlock
+-151	common	mlockall		sys_mlockall
+-152	common	munlockall		sys_munlockall
+-153	common	vhangup			sys_vhangup
+-154	common	modify_ldt		sys_modify_ldt
+-155	common	pivot_root		sys_pivot_root
+-156	64	_sysctl			sys_sysctl
+-157	common	prctl			sys_prctl
+-158	common	arch_prctl		sys_arch_prctl
+-159	common	adjtimex		sys_adjtimex
++160	common	setrlimit		sys_setrlimit
+-161	common	chroot			sys_chroot
+-162	common	sync			sys_sync
+-163	common	acct			sys_acct
+-164	common	settimeofday		sys_settimeofday
+165	common	mount			sys_mount
+-166	common	umount2			sys_umount
+-167	common	swapon			sys_swapon
+-168	common	swapoff			sys_swapoff
+-169	common	reboot			sys_reboot
+-170	common	sethostname		sys_sethostname
+-171	common	setdomainname		sys_setdomainname
+-172	common	iopl			stub_iopl
+-173	common	ioperm			sys_ioperm
+174	64	create_module
+-175	common	init_module		sys_init_module
+-176	common	delete_module		sys_delete_module
+177	64	get_kernel_syms
+178	64	query_module
+-179	common	quotactl		sys_quotactl
+180	64	nfsservctl
+181	common	getpmsg
+182	common	putpmsg
+183	common	afs_syscall
+184	common	tuxcall
+185	common	security
++186	common	gettid			sys_gettid
+-187	common	readahead		sys_readahead
+-188	common	setxattr		sys_setxattr
+-189	common	lsetxattr		sys_lsetxattr
+-190	common	fsetxattr		sys_fsetxattr
+-191	common	getxattr		sys_getxattr
+-192	common	lgetxattr		sys_lgetxattr
+-193	common	fgetxattr		sys_fgetxattr
+-194	common	listxattr		sys_listxattr
+-195	common	llistxattr		sys_llistxattr
+-196	common	flistxattr		sys_flistxattr
+-197	common	removexattr		sys_removexattr
+-198	common	lremovexattr		sys_lremovexattr
+-199	common	fremovexattr		sys_fremovexattr
+-200	common	tkill			sys_tkill
++201	common	time			sys_time
+202	common	futex			sys_futex
+-203	common	sched_setaffinity	sys_sched_setaffinity
++204	common	sched_getaffinity	sys_sched_getaffinity
+205	64	set_thread_area
+-206	common	io_setup		sys_io_setup
+-207	common	io_destroy		sys_io_destroy
+-208	common	io_getevents		sys_io_getevents
+-209	common	io_submit		sys_io_submit
+-210	common	io_cancel		sys_io_cancel
+211	64	get_thread_area
+-212	common	lookup_dcookie		sys_lookup_dcookie
+-213	common	epoll_create		sys_epoll_create
+214	64	epoll_ctl_old
+215	64	epoll_wait_old
+-216	common	remap_file_pages	sys_remap_file_pages
++217	common	getdents64		sys_getdents64
+218	common	set_tid_address		sys_set_tid_address
++219	common	restart_syscall		sys_restart_syscall
+-220	common	semtimedop		sys_semtimedop
+-221	common	fadvise64		sys_fadvise64
+222	64	timer_create		sys_timer_create
+223	common	timer_settime		sys_timer_settime
+224	common	timer_gettime		sys_timer_gettime
+225	common	timer_getoverrun	sys_timer_getoverrun
+226	common	timer_delete		sys_timer_delete
+227	common	clock_settime		sys_clock_settime
+228	common	clock_gettime		sys_clock_gettime
+229	common	clock_getres		sys_clock_getres
+230	common	clock_nanosleep		sys_clock_nanosleep
+231	common	exit_group		sys_exit_group
+-232	common	epoll_wait		sys_epoll_wait
+-233	common	epoll_ctl		sys_epoll_ctl
+-234	common	tgkill			sys_tgkill
+-235	common	utimes			sys_utimes
+236	64	vserver
+-237	common	mbind			sys_mbind
+-238	common	set_mempolicy		sys_set_mempolicy
+-239	common	get_mempolicy		sys_get_mempolicy
+-240	common	mq_open			sys_mq_open
+-241	common	mq_unlink		sys_mq_unlink
+-242	common	mq_timedsend		sys_mq_timedsend
+-243	common	mq_timedreceive		sys_mq_timedreceive
+-244	64	mq_notify		sys_mq_notify
+-245	common	mq_getsetattr		sys_mq_getsetattr
+-246	64	kexec_load		sys_kexec_load
+247	64	waitid			sys_waitid
+-248	common	add_key			sys_add_key
+-249	common	request_key		sys_request_key
+-250	common	keyctl			sys_keyctl
+-251	common	ioprio_set		sys_ioprio_set
++252	common	ioprio_get		sys_ioprio_get
+-253	common	inotify_init		sys_inotify_init
+-254	common	inotify_add_watch	sys_inotify_add_watch
+-255	common	inotify_rm_watch	sys_inotify_rm_watch
+-256	common	migrate_pages		sys_migrate_pages
+-257	common	openat			sys_openat
+-258	common	mkdirat			sys_mkdirat
+-259	common	mknodat			sys_mknodat
+-260	common	fchownat		sys_fchownat
+-261	common	futimesat		sys_futimesat
+-262	common	newfstatat		sys_newfstatat
+-263	common	unlinkat		sys_unlinkat
+-264	common	renameat		sys_renameat
+-265	common	linkat			sys_linkat
+-266	common	symlinkat		sys_symlinkat
+-267	common	readlinkat		sys_readlinkat
+-268	common	fchmodat		sys_fchmodat
+-269	common	faccessat		sys_faccessat
+270	common	pselect6		sys_pselect6
+271	common	ppoll			sys_ppoll
+272	common	unshare			sys_unshare
+273	64	set_robust_list		sys_set_robust_list
+274	64	get_robust_list		sys_get_robust_list
+-275	common	splice			sys_splice
+-276	common	tee			sys_tee
+-277	common	sync_file_range		sys_sync_file_range
+-278	64	vmsplice		sys_vmsplice
+-279	64	move_pages		sys_move_pages
+-280	common	utimensat		sys_utimensat
+-281	common	epoll_pwait		sys_epoll_pwait
+-282	common	signalfd		sys_signalfd
+-283	common	timerfd_create		sys_timerfd_create
+-284	common	eventfd			sys_eventfd
+-285	common	fallocate		sys_fallocate
+-286	common	timerfd_settime		sys_timerfd_settime
+-287	common	timerfd_gettime		sys_timerfd_gettime
+-288	common	accept4			sys_accept4
+-289	common	signalfd4		sys_signalfd4
+-290	common	eventfd2		sys_eventfd2
+-291	common	epoll_create1		sys_epoll_create1
+292	common	dup3			sys_dup3
+-293	common	pipe2			sys_pipe2
+-294	common	inotify_init1		sys_inotify_init1
+-295	64	preadv			sys_preadv
+-296	64	pwritev			sys_pwritev
++297	64	rt_tgsigqueueinfo	sys_rt_tgsigqueueinfo
+-298	common	perf_event_open		sys_perf_event_open
+-299	64	recvmmsg		sys_recvmmsg
+-300	common	fanotify_init		sys_fanotify_init
+-301	common	fanotify_mark		sys_fanotify_mark
+-302	common	prlimit64		sys_prlimit64
+-303	common	name_to_handle_at	sys_name_to_handle_at
+-304	common	open_by_handle_at	sys_open_by_handle_at
+305	common	clock_adjtime		sys_clock_adjtime
+-306	common	syncfs			sys_syncfs
+-307	64	sendmmsg		sys_sendmmsg
+-308	common	setns			sys_setns
++309	common	getcpu			sys_getcpu
+-310	64	process_vm_readv	sys_process_vm_readv
+-311	64	process_vm_writev	sys_process_vm_writev
+-312	common	kcmp			sys_kcmp
+-313	common	finit_module		sys_finit_module
+
+#
+# x32-specific system call numbers start at 512 to avoid cache impact
+# for native 64-bit operation.
+#
++512	x32	rt_sigaction		compat_sys_rt_sigaction
+513	x32	rt_sigreturn		stub_x32_rt_sigreturn
+-514	x32	ioctl			-compat_sys_ioctl
++515	x32	readv			compat_sys_readv
++516	x32	writev			compat_sys_writev
+517	x32	recvfrom		-compat_sys_recvfrom
+-518	x32	sendmsg			compat_sys_sendmsg
+-519	x32	recvmsg			-compat_sys_recvmsg
+-520	x32	execve			stub_x32_execve
+-521	x32	ptrace			compat_sys_ptrace
++522	x32	rt_sigpending		compat_sys_rt_sigpending
++523	x32	rt_sigtimedwait		+compat_sys_rt_sigtimedwait
++524	x32	rt_sigqueueinfo		compat_sys_rt_sigqueueinfo
+-525	x32	sigaltstack		compat_sys_sigaltstack
+526	x32	timer_create		-compat_sys_timer_create
+-527	x32	mq_notify		compat_sys_mq_notify
+-528	x32	kexec_load		compat_sys_kexec_load
+529	x32	waitid			?compat_sys_waitid
+530	x32	set_robust_list		compat_sys_set_robust_list
+531	x32	get_robust_list		compat_sys_get_robust_list
+-532	x32	vmsplice		compat_sys_vmsplice
+-533	x32	move_pages		-compat_sys_move_pages
+-534	x32	preadv			compat_sys_preadv64
+-535	x32	pwritev			compat_sys_pwritev64
++536	x32	rt_tgsigqueueinfo	compat_sys_rt_tgsigqueueinfo
+-537	x32	recvmmsg		compat_sys_recvmmsg
+-538	x32	sendmmsg		compat_sys_sendmmsg
+-539	x32	process_vm_readv	compat_sys_process_vm_readv
+-540	x32	process_vm_writev	compat_sys_process_vm_writev
+-541	x32	setsockopt		compat_sys_setsockopt
+-542	x32	getsockopt		compat_sys_getsockopt
diff -ruNp linux-3.12.6/fs/aio.c linux-3.12.6-cher1/fs/aio.c
--- linux-3.12.6/fs/aio.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/aio.c	2013-12-24 13:58:59.384817170 +0400
@@ -1130,6 +1130,9 @@ SYSCALL_DEFINE2(io_setup, unsigned, nr_e
 	unsigned long ctx;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ret = get_user(ctx, ctxp);
 	if (unlikely(ret))
 		goto out;
@@ -1162,7 +1165,13 @@ out:
  */
 SYSCALL_DEFINE1(io_destroy, aio_context_t, ctx)
 {
-	struct kioctx *ioctx = lookup_ioctx(ctx);
+	struct kioctx *ioctx = NULL;
+
+        if (SBOX_IS_RESTRICTED()) {
+                return -EPERM;
+        }
+
+	ioctx = lookup_ioctx(ctx);
 	if (likely(NULL != ioctx)) {
 		kill_ioctx(current->mm, ioctx);
 		percpu_ref_put(&ioctx->users);
@@ -1465,6 +1474,9 @@ long do_io_submit(aio_context_t ctx_id,
 SYSCALL_DEFINE3(io_submit, aio_context_t, ctx_id, long, nr,
 		struct iocb __user * __user *, iocbpp)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	return do_io_submit(ctx_id, nr, iocbpp, 0);
 }
 
@@ -1508,6 +1520,9 @@ SYSCALL_DEFINE3(io_cancel, aio_context_t
 	u32 key;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ret = get_user(key, &iocb->aio_key);
 	if (unlikely(ret))
 		return -EFAULT;
@@ -1558,9 +1573,13 @@ SYSCALL_DEFINE5(io_getevents, aio_contex
 		struct io_event __user *, events,
 		struct timespec __user *, timeout)
 {
-	struct kioctx *ioctx = lookup_ioctx(ctx_id);
+	struct kioctx *ioctx;
 	long ret = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        ioctx = lookup_ioctx(ctx_id);
 	if (likely(ioctx)) {
 		if (likely(min_nr <= nr && min_nr >= 0))
 			ret = read_events(ioctx, min_nr, nr, events, timeout);
diff -ruNp linux-3.12.6/fs/buffer.c linux-3.12.6-cher1/fs/buffer.c
--- linux-3.12.6/fs/buffer.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/buffer.c	2013-12-24 13:58:59.384817170 +0400
@@ -3280,6 +3280,9 @@ SYSCALL_DEFINE2(bdflush, int, func, long
 {
 	static int msg_count;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
diff -ruNp linux-3.12.6/fs/compat.c linux-3.12.6-cher1/fs/compat.c
--- linux-3.12.6/fs/compat.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/compat.c	2013-12-24 13:58:59.385817178 +0400
@@ -77,6 +77,11 @@ asmlinkage long compat_sys_utime(const c
 {
 	struct timespec tv[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (t) {
 		if (get_user(tv[0].tv_sec, &t->actime) ||
 		    get_user(tv[1].tv_sec, &t->modtime))
@@ -91,6 +96,11 @@ asmlinkage long compat_sys_utimensat(uns
 {
 	struct timespec tv[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if  (t) {
 		if (get_compat_timespec(&tv[0], &t[0]) ||
 		    get_compat_timespec(&tv[1], &t[1]))
@@ -106,6 +116,11 @@ asmlinkage long compat_sys_futimesat(uns
 {
 	struct timespec tv[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (t) {
 		if (get_user(tv[0].tv_sec, &t[0].tv_sec) ||
 		    get_user(tv[0].tv_nsec, &t[0].tv_usec) ||
@@ -159,12 +174,25 @@ static int cp_compat_stat(struct kstat *
 	return copy_to_user(ubuf, &tmp, sizeof(tmp)) ? -EFAULT : 0;
 }
 
+int cher_patch_is_secure_path(const char*);
+
 asmlinkage long compat_sys_newstat(const char __user * filename,
 		struct compat_stat __user *statbuf)
 {
 	struct kstat stat;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                struct filename *tmp = getname(filename);
+                if (IS_ERR(tmp)) return -EINVAL;
+                if (cher_patch_is_secure_path(tmp->name) < 0) {
+                        putname(tmp);
+                        return -EPERM;
+                }
+                if (!strncmp(tmp->name, "/SANDBOX/", 9)) filename += 9;
+                putname(tmp);
+        }
+
 	error = vfs_stat(filename, &stat);
 	if (error)
 		return error;
@@ -177,6 +205,17 @@ asmlinkage long compat_sys_newlstat(cons
 	struct kstat stat;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                struct filename *tmp = getname(filename);
+                if (IS_ERR(tmp)) return -EINVAL;
+                if (cher_patch_is_secure_path(tmp->name) < 0) {
+                        putname(tmp);
+                        return -EPERM;
+                }
+                if (!strncmp(tmp->name, "/SANDBOX/", 9)) filename += 9;
+                putname(tmp);
+        }
+
 	error = vfs_lstat(filename, &stat);
 	if (error)
 		return error;
@@ -191,6 +230,9 @@ asmlinkage long compat_sys_newfstatat(un
 	struct kstat stat;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = vfs_fstatat(dfd, filename, &stat, flag);
 	if (error)
 		return error;
@@ -250,7 +292,12 @@ static int put_compat_statfs(struct comp
 asmlinkage long compat_sys_statfs(const char __user *pathname, struct compat_statfs __user *buf)
 {
 	struct kstatfs tmp;
-	int error = user_statfs(pathname, &tmp);
+	int error;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        error = user_statfs(pathname, &tmp);
 	if (!error)
 		error = put_compat_statfs(buf, &tmp);
 	return error;
@@ -259,7 +306,12 @@ asmlinkage long compat_sys_statfs(const
 asmlinkage long compat_sys_fstatfs(unsigned int fd, struct compat_statfs __user *buf)
 {
 	struct kstatfs tmp;
-	int error = fd_statfs(fd, &tmp);
+	int error;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        error = fd_statfs(fd, &tmp);
 	if (!error)
 		error = put_compat_statfs(buf, &tmp);
 	return error;
@@ -303,6 +355,9 @@ asmlinkage long compat_sys_statfs64(cons
 	struct kstatfs tmp;
 	int error;
 
+       if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -317,6 +372,9 @@ asmlinkage long compat_sys_fstatfs64(uns
 	struct kstatfs tmp;
 	int error;
 
+       if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -335,7 +393,12 @@ asmlinkage long compat_sys_ustat(unsigne
 {
 	struct compat_ustat tmp;
 	struct kstatfs sbuf;
-	int err = vfs_ustat(new_decode_dev(dev), &sbuf);
+	int err;
+
+       if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        err = vfs_ustat(new_decode_dev(dev), &sbuf);
 	if (err)
 		return err;
 
@@ -406,6 +469,9 @@ asmlinkage long compat_sys_fcntl64(unsig
 	struct flock f;
 	long ret;
 
+       if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	switch (cmd) {
 	case F_GETLK:
 	case F_SETLK:
@@ -483,6 +549,10 @@ compat_sys_io_setup(unsigned nr_reqs, u3
 	aio_context_t ctx64;
 
 	mm_segment_t oldfs = get_fs();
+
+       if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (unlikely(get_user(ctx64, ctx32p)))
 		return -EFAULT;
 
@@ -507,6 +577,9 @@ compat_sys_io_getevents(aio_context_t ct
 	struct timespec t;
 	struct timespec __user *ut = NULL;
 
+       if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ret = -EFAULT;
 	if (unlikely(!access_ok(VERIFY_WRITE, events, 
 				nr * sizeof(struct io_event))))
@@ -623,6 +696,9 @@ compat_sys_io_submit(aio_context_t ctx_i
 	struct iocb __user * __user *iocb64; 
 	long ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (unlikely(nr < 0))
 		return -EINVAL;
 
@@ -781,6 +857,11 @@ asmlinkage long compat_sys_mount(const c
 	struct filename *dir;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	retval = copy_mount_string(type, &kernel_type);
 	if (retval < 0)
 		goto out;
@@ -882,6 +963,13 @@ asmlinkage long compat_sys_old_readdir(u
 	if (!f.file)
 		return -EBADF;
 
+        /*
+        if (SBOX_IS_RESTRICTED()) {
+                fdput(fd);
+                return -EPERM;
+        }
+        */
+
 	error = iterate_dir(f.file, &buf.ctx);
 	if (buf.result)
 		error = buf.result;
@@ -960,6 +1048,11 @@ asmlinkage long compat_sys_getdents(unsi
 	};
 	int error;
 
+        /*
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+        */
+
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		return -EFAULT;
 
@@ -1045,6 +1138,11 @@ asmlinkage long compat_sys_getdents64(un
 	};
 	int error;
 
+        /*
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+        */
+
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		return -EFAULT;
 
@@ -1083,6 +1181,10 @@ COMPAT_SYSCALL_DEFINE3(open, const char
  */
 COMPAT_SYSCALL_DEFINE4(openat, int, dfd, const char __user *, filename, int, flags, umode_t, mode)
 {
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
 	return do_sys_open(dfd, filename, flags, mode);
 }
 
@@ -1461,6 +1563,11 @@ asmlinkage long compat_sys_ppoll(struct
 COMPAT_SYSCALL_DEFINE3(open_by_handle_at, int, mountdirfd,
 			     struct file_handle __user *, handle, int, flags)
 {
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	return do_handle_open(mountdirfd, handle, flags);
 }
 #endif
diff -ruNp linux-3.12.6/fs/compat_ioctl.c linux-3.12.6-cher1/fs/compat_ioctl.c
--- linux-3.12.6/fs/compat_ioctl.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/compat_ioctl.c	2013-12-24 13:58:59.385817178 +0400
@@ -1545,6 +1545,9 @@ asmlinkage long compat_sys_ioctl(unsigne
 	if (!f.file)
 		goto out;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* RED-PEN how should LSM module know it's handling 32bit? */
 	error = security_file_ioctl(f.file, cmd, arg);
 	if (error)
diff -ruNp linux-3.12.6/fs/dcache.c linux-3.12.6-cher1/fs/dcache.c
--- linux-3.12.6/fs/dcache.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/dcache.c	2013-12-24 13:58:59.385817178 +0400
@@ -3218,8 +3218,14 @@ SYSCALL_DEFINE2(getcwd, char __user *, b
 {
 	int error;
 	struct path pwd, root;
-	char *page = __getname();
+	char *page = 0;
 
+        if (SBOX_IS_RESTRICTED()) {
+                copy_to_user(buf, "/SANDBOX", 9);
+                return 9;
+        }
+
+        page = __getname();
 	if (!page)
 		return -ENOMEM;
 
diff -ruNp linux-3.12.6/fs/dcookies.c linux-3.12.6-cher1/fs/dcookies.c
--- linux-3.12.6/fs/dcookies.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/dcookies.c	2013-12-24 13:58:59.386817183 +0400
@@ -155,6 +155,11 @@ SYSCALL_DEFINE3(lookup_dcookie, u64, coo
 	size_t pathlen;
 	struct dcookie_struct * dcs;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	/* we could leak path information to users
 	 * without dir read permission without this
 	 */
diff -ruNp linux-3.12.6/fs/eventfd.c linux-3.12.6-cher1/fs/eventfd.c
--- linux-3.12.6/fs/eventfd.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/eventfd.c	2013-12-24 13:58:59.386817183 +0400
@@ -428,6 +428,9 @@ SYSCALL_DEFINE2(eventfd2, unsigned int,
 	int fd, error;
 	struct file *file;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = get_unused_fd_flags(flags & EFD_SHARED_FCNTL_FLAGS);
 	if (error < 0)
 		return error;
diff -ruNp linux-3.12.6/fs/eventpoll.c linux-3.12.6-cher1/fs/eventpoll.c
--- linux-3.12.6/fs/eventpoll.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/eventpoll.c	2013-12-24 13:58:59.386817183 +0400
@@ -1737,6 +1737,9 @@ SYSCALL_DEFINE1(epoll_create1, int, flag
 	struct eventpoll *ep = NULL;
 	struct file *file;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* Check the EPOLL_* constant for consistency.  */
 	BUILD_BUG_ON(EPOLL_CLOEXEC != O_CLOEXEC);
 
@@ -1797,6 +1800,9 @@ SYSCALL_DEFINE4(epoll_ctl, int, epfd, in
 	struct epitem *epi;
 	struct epoll_event epds;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = -EFAULT;
 	if (ep_op_has_event(op) &&
 	    copy_from_user(&epds, event, sizeof(struct epoll_event)))
@@ -1921,6 +1927,9 @@ SYSCALL_DEFINE4(epoll_wait, int, epfd, s
 	struct fd f;
 	struct eventpoll *ep;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* The maximum number of event must be greater than zero */
 	if (maxevents <= 0 || maxevents > EP_MAX_EVENTS)
 		return -EINVAL;
@@ -1967,6 +1976,9 @@ SYSCALL_DEFINE6(epoll_pwait, int, epfd,
 	int error;
 	sigset_t ksigmask, sigsaved;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/*
 	 * If the caller wants a certain signal mask to be set during the wait,
 	 * we apply it here.
diff -ruNp linux-3.12.6/fs/exec.c linux-3.12.6-cher1/fs/exec.c
--- linux-3.12.6/fs/exec.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/exec.c	2013-12-24 13:58:59.386817183 +0400
@@ -119,6 +119,11 @@ SYSCALL_DEFINE1(uselib, const char __use
 	if (IS_ERR(tmp))
 		goto out;
 
+        if (SBOX_IS_RESTRICTED()) {
+                putname(tmp);
+                return -EPERM;
+        }
+
 	file = do_filp_open(AT_FDCWD, tmp, &uselib_flags);
 	putname(tmp);
 	error = PTR_ERR(file);
@@ -1684,10 +1689,23 @@ SYSCALL_DEFINE3(execve,
 		const char __user *const __user *, argv,
 		const char __user *const __user *, envp)
 {
-	struct filename *path = getname(filename);
-	int error = PTR_ERR(path);
+	struct filename *path = NULL;
+	int error = 0;
+
+        if ((current->sbox_flags & SBOX_NO_EXEC)) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
+	path = getname(filename);
+	error = PTR_ERR(path);
 	if (!IS_ERR(path)) {
 		error = do_execve(path->name, argv, envp);
+                if (!error) {
+                        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                                current->sbox_flags |= SBOX_NO_EXEC;
+                        }
+                }
 		putname(path);
 	}
 	return error;
@@ -1697,10 +1715,23 @@ asmlinkage long compat_sys_execve(const
 	const compat_uptr_t __user * argv,
 	const compat_uptr_t __user * envp)
 {
-	struct filename *path = getname(filename);
-	int error = PTR_ERR(path);
+	struct filename *path = NULL;
+	int error = 0;
+
+        if ((current->sbox_flags & SBOX_NO_EXEC)) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
+	path = getname(filename);
+	error = PTR_ERR(path);
 	if (!IS_ERR(path)) {
 		error = compat_do_execve(path->name, argv, envp);
+                if (!error) {
+                        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                                current->sbox_flags |= SBOX_NO_EXEC;
+                        }
+                }
 		putname(path);
 	}
 	return error;
diff -ruNp linux-3.12.6/fs/fcntl.c linux-3.12.6-cher1/fs/fcntl.c
--- linux-3.12.6/fs/fcntl.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/fcntl.c	2013-12-24 13:58:59.402817365 +0400
@@ -351,6 +351,10 @@ SYSCALL_DEFINE3(fcntl, unsigned int, fd,
 	struct fd f = fdget_raw(fd);
 	long err = -EBADF;
 
+        if (SBOX_IS_RESTRICTED()) {
+                return -EPERM;
+        }
+
 	if (!f.file)
 		goto out;
 
@@ -376,6 +380,10 @@ SYSCALL_DEFINE3(fcntl64, unsigned int, f
 	struct fd f = fdget_raw(fd);
 	long err = -EBADF;
 
+        if (SBOX_IS_RESTRICTED()) {
+                return -EPERM;
+        }
+
 	if (!f.file)
 		goto out;
 
diff -ruNp linux-3.12.6/fs/fhandle.c linux-3.12.6-cher1/fs/fhandle.c
--- linux-3.12.6/fs/fhandle.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/fhandle.c	2013-12-24 13:58:59.402817365 +0400
@@ -97,6 +97,11 @@ SYSCALL_DEFINE5(name_to_handle_at, int,
 	int lookup_flags;
 	int err;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if ((flag & ~(AT_SYMLINK_FOLLOW | AT_EMPTY_PATH)) != 0)
 		return -EINVAL;
 
@@ -257,6 +262,11 @@ SYSCALL_DEFINE3(open_by_handle_at, int,
 {
 	long ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (force_o_largefile())
 		flags |= O_LARGEFILE;
 
diff -ruNp linux-3.12.6/fs/filesystems.c linux-3.12.6-cher1/fs/filesystems.c
--- linux-3.12.6/fs/filesystems.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/filesystems.c	2013-12-24 13:58:59.402817365 +0400
@@ -184,6 +184,11 @@ SYSCALL_DEFINE3(sysfs, int, option, unsi
 {
 	int retval = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	switch (option) {
 		case 1:
 			retval = fs_index((const char __user *) arg1);
diff -ruNp linux-3.12.6/fs/ioctl.c linux-3.12.6-cher1/fs/ioctl.c
--- linux-3.12.6/fs/ioctl.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/ioctl.c	2013-12-24 13:58:59.402817365 +0400
@@ -608,6 +608,12 @@ SYSCALL_DEFINE3(ioctl, unsigned int, fd,
 
 	if (!f.file)
 		return -EBADF;
+
+        if (SBOX_IS_RESTRICTED()) {
+                fdput(f);
+                return -EPERM;
+        }
+
 	error = security_file_ioctl(f.file, cmd, arg);
 	if (!error)
 		error = do_vfs_ioctl(f.file, fd, cmd, arg);
diff -ruNp linux-3.12.6/fs/ioprio.c linux-3.12.6-cher1/fs/ioprio.c
--- linux-3.12.6/fs/ioprio.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/ioprio.c	2013-12-24 13:58:59.402817365 +0400
@@ -68,6 +68,9 @@ SYSCALL_DEFINE3(ioprio_set, int, which,
 	kuid_t uid;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	switch (class) {
 		case IOPRIO_CLASS_RT:
 			if (!capable(CAP_SYS_ADMIN))
diff -ruNp linux-3.12.6/fs/locks.c linux-3.12.6-cher1/fs/locks.c
--- linux-3.12.6/fs/locks.c	2013-12-20 19:51:33.000000000 +0400
+++ linux-3.12.6-cher1/fs/locks.c	2013-12-24 13:58:59.402817365 +0400
@@ -1753,6 +1753,11 @@ SYSCALL_DEFINE2(flock, unsigned int, fd,
 	if (!f.file)
 		goto out;
 
+        if (SBOX_IS_RESTRICTED()) {
+                fdput(f);
+                return -EPERM;
+        }
+
 	can_sleep = !(cmd & LOCK_NB);
 	cmd &= ~LOCK_NB;
 	unlock = (cmd == LOCK_UN);
